<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';

interface IntroCard {
  name: string;
  description: string;
  href: string;
  icon: string;
  linkText: string;
}

export default Vue.extend({
  props: {
    header: {
      type: String,
      required: true,
    },
    icon: {
      type: String,
      required: true,
    },
    cards: {
      type: Array as PropType<IntroCard[]>,
      required: true,
    },
  },
});
</script>

<template>
  <div class="card-intro">
    <div class="header">
      <SlpIcon :name="icon" size="48" variant="marketing" />
      <SlpTypography variant="heading3-bold" tag="h3">{{
        header
      }}</SlpTypography>
    </div>
    <div class="card-container">
      <a
        v-for="card in cards"
        :key="card.name"
        class="intro-card"
        :href="card.href"
        :data-ga-name="card.name.toLocaleLowerCase()"
        data-ga-location="body"
      >
        <SlpIcon :name="card.icon" size="48" variant="marketing" />
        <SlpTypography variant="heading5-bold">{{ card.name }}</SlpTypography>
        <SlpTypography variant="body3">{{ card.description }}</SlpTypography>
        <SlpButton v-if="card.linkText" variant="tertiary"
          >{{ card.linkText }} <SlpIcon name="chevron-right" variant="product"
        /></SlpButton>
      </a>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.card-intro {
  display: flex;
  flex-direction: column;
  gap: 48px;
  margin: 96px 0;
  .header {
    display: flex;
    gap: 14px;
    align-items: center;
    justify-content: flex-start;
  }
  .card-container {
    display: grid;
    grid-template-columns: 1fr;
    gap: 16px;
    @media (min-width: $breakpoint-lg) {
      grid-template-columns: repeat(3, 1fr);
    }
    .intro-card {
      cursor: pointer;
      display: flex;
      color: $color-text-300;

      flex-direction: column;
      gap: 16px;
      padding: 44px 32px;
      justify-content: space-between;
      background-color: $color-surface-800;
      min-height: 250px;
      border-radius: 4px;
      transition: all 0.3s;

      &:hover {
        border-radius: 4px 4px 90px 4px;
        background: linear-gradient(
          93.83deg,
          rgba(199, 177, 254, 0.4) 7.27%,
          rgba(255, 212, 216, 0.4) 105.33%
        );
      }
    }
  }
}
</style>
